/*
   $RCSfile: momessgc.h,v $       $Revision: 1.4 $
   $State: V7_0 $                  $Date: 2004/06/03 13:42:13 $
*/
#ifndef _MOMESSGC_H
#define _MOMESSGC_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Xm.h>

#include "uttypesu.h"

typedef enum {
   QuestionResponseNo,
   QuestionResponseYes,
   QuestionResponseYesAll
} moQuestionResponse;

#ifdef __STDC__
   extern moQuestionResponse moAskQuestion(char *question);
   extern void momessgActYesPB(Widget w,
                               XtPointer client_data,
                               XtPointer xt_call_data);
   extern void momessgActYallPB(Widget w,
                                XtPointer client_data,
                                XtPointer xt_call_data);
   extern void momessgActNoPB(Widget w,
                              XtPointer client_data,
                              XtPointer xt_call_data);
   extern utLogical moSendQuestion(char *question);
   extern void moSendError(char *error);
   extern void moSendWarning(char *warning);
   extern void moSendWorking(char *working);
   extern void moSendInformation(char *information);
   extern void moSendMessage(char *message);
   extern void momessgHelpFM(Widget w,
                             XtPointer client_data,
                             XtPointer xt_call_data);
#else
   extern moQuestionResponse moAskQuestion();
   extern void momessgActYesPB();
   extern void momessgActYallPB();
   extern void momessgActNoPB();
   extern utLogical moSendQuestion();
   extern void moSendError();
   extern void moSendWarning();
   extern void moSendWorking();
   extern void moSendInformation();
   extern void moSendMessage();
   extern void momessgHelpFM();
#endif

#ifdef __cplusplus
   }
#endif

#endif
