/*
  $RCSfile: mopushbw.h,v $       $Revision: 1.3 $
  $State: Exp $                  $Date: 2002/05/28 17:28:17 $
*/
#ifndef _MOBUSHBW_H
#define _MOBUSHBW_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/PushB.h>
#include <Xm/PushBG.h>

#include "uttypesu.h"

#include "moclrslu.h"

#ifdef __STDC__
   extern void             moClearPB(Widget wPushButton);
   extern void             moSetCstringToPB(Widget wPushButton,
                                            char *pushButtonLabel);
   extern char            *moGetCstringFromPB(Widget wPushButton);
   extern ColorIdentifier  moGetOptionalPushButtonColorId();
   extern void             moDisableInputPB(Widget wPushButton);
   extern void             moEnableInputPB(Widget wPushButton);
   extern utLogical        moIsInputEnabledPB(Widget wPushButton);
#else
   extern void             moClearPB();
   extern void             moSetCstringToPB();
   extern char            *moGetCstringFromPB();
   extern ColorIdentifier  moGetOptionalPushButtonColorId();
   extern void             moDisableInputPB();
   extern void             moEnableInputPB();
   extern utLogical        moIsInputEnabledPB();
#endif

#ifdef __cplusplus
   }
#endif

#endif
