/*
  $RCSfile: moscrbrw.c,v $       $Revision: 1.5 $
  $State: V7_1 $                  $Date: 2004/11/04 17:49:26 $
*/
#include <Xm/Form.h>
#include <Xm/FileSB.h>

#include "utmacrou.h"

#include "momotifu.h"
#include "moscrbrw.h"

#ifdef __STDC__
void moGetMinimumSB(Widget wScrollBar,
                    double *minimum)
#else
void moGetMinimumSB(wScrollBar,
                    minimum)
Widget  wScrollBar;
double *minimum;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarMinimum;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNminimum,&scrollBarMinimum); ac++;
   XtGetValues(wScrollBar,al,ac);

   *minimum = scrollBarMinimum;
}


#ifdef __STDC__
void moSetMinimumSB(Widget wScrollBar,
                    double minimum)
#else
void moSetMinimumSB(wScrollBar,
                    minimum)
Widget wScrollBar;
double minimum;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarMinimum = (int)minimum;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   if((double)scrollBarMinimum > minimum)
      scrollBarMinimum--;

   XtSetArg(al[ac],XmNminimum,scrollBarMinimum); ac++;
   XtSetValues(wScrollBar,al,ac);
}


#ifdef __STDC__
void moGetMaximumSB(Widget wScrollBar,
                    double *maximum)
#else
void moGetMaximumSB(wScrollBar,
                    maximum)
Widget  wScrollBar;
double *maximum;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarMaximum;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNmaximum,&scrollBarMaximum); ac++;
   XtGetValues(wScrollBar,al,ac);

   *maximum = scrollBarMaximum;
}


#ifdef __STDC__
void moSetMaximumSB(Widget wScrollBar,
                    double maximum)
#else
void moSetMaximumSB(wScrollBar,
                    maximum)
Widget wScrollBar;
double maximum;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarMaximum = (int)maximum;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   if((double)scrollBarMaximum < maximum)
      scrollBarMaximum++;

   XtSetArg(al[ac],XmNmaximum,scrollBarMaximum); ac++;
   XtSetValues(wScrollBar,al,ac);
}


#ifdef __STDC__
void moGetIncrementSB(Widget wScrollBar,
                      double *increment)
#else
void moGetIncrementSB(wScrollBar,
                      increment)
Widget  wScrollBar;
double *increment;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarIncrement;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNincrement,&scrollBarIncrement); ac++;
   XtGetValues(wScrollBar,al,ac);

   *increment = scrollBarIncrement;
}


#ifdef __STDC__
void moSetIncrementSB(Widget wScrollBar,
                      double increment)
#else
void moSetIncrementSB(wScrollBar,
                      increment)
Widget wScrollBar;
double increment;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarIncrement = (int)increment;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   if(scrollBarIncrement == 0)
      scrollBarIncrement = 1;

   XtSetArg(al[ac],XmNincrement,scrollBarIncrement); ac++;
   XtSetValues(wScrollBar,al,ac);
}


#ifdef __STDC__
void moGetPageIncrementSB(Widget wScrollBar,
                          double *pageIncrement)
#else
void moGetPageIncrementSB(wScrollBar,
                          pageIncrement)
Widget  wScrollBar;
double *pageIncrement;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarPageIncrement;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNpageIncrement,&scrollBarPageIncrement); ac++;
   XtGetValues(wScrollBar,al,ac);

   *pageIncrement = scrollBarPageIncrement;
}


#ifdef __STDC__
void moSetPageIncrementSB(Widget wScrollBar,
                          double pageIncrement)
#else
void moSetPageIncrementSB(wScrollBar,
                          pageIncrement)
Widget wScrollBar;
double pageIncrement;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarPageIncrement = (int)pageIncrement;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNpageIncrement,scrollBarPageIncrement); ac++;
   XtSetValues(wScrollBar,al,ac);
}


#ifdef __STDC__
void moGetSliderSizeSB(Widget wScrollBar,
                       double *sliderSize)
#else
void moGetSliderSizeSB(wScrollBar,
                       sliderSize)
Widget  wScrollBar;
double *sliderSize;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarSliderSize;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNsliderSize,&scrollBarSliderSize); ac++;
   XtGetValues(wScrollBar,al,ac);

   *sliderSize = scrollBarSliderSize;
}


#ifdef __STDC__
void moSetSliderSizeSB(Widget wScrollBar,
                       double sliderSize)
#else
void moSetSliderSizeSB(wScrollBar,
                       sliderSize)
Widget wScrollBar;
double sliderSize;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarSliderSize = (int)sliderSize;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNsliderSize,scrollBarSliderSize); ac++;
   XtSetValues(wScrollBar,al,ac);
}


#ifdef __STDC__
void moGetSliderValueSB(Widget wScrollBar,
                        double *sliderValue)
#else
void moGetSliderValueSB(wScrollBar,
                        sliderValue)
Widget  wScrollBar;
double *sliderValue;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarSliderValue;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNvalue,&scrollBarSliderValue); ac++;
   XtGetValues(wScrollBar,al,ac);

   *sliderValue = scrollBarSliderValue;
}


#ifdef __STDC__
void moSetSliderValueSB(Widget wScrollBar,
                        double sliderValue)
#else
void moSetSliderValueSB(wScrollBar,
                        sliderValue)
Widget wScrollBar;
double sliderValue;
#endif
{
   int ac = 0;
   Arg al[1];
   int scrollBarSliderValue = (int)sliderValue;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   XtSetArg(al[ac],XmNvalue,scrollBarSliderValue); ac++;
   XtSetValues(wScrollBar,al,ac);
}


#ifdef __STDC__
void moSetValuesSB(Widget wScrollBar,
                   double minimum,
                   double maximum,
                   double increment,
                   double pageIncrement,
                   double sliderSize,
                   double sliderValue)
#else
void moSetValuesSB(wScrollBar,
                   minimum,
                   maximum,
                   increment,
                   pageIncrement,
                   sliderSize,
                   sliderValue)
Widget wScrollBar;
double minimum;
double maximum;
double increment;
double pageIncrement;
double sliderSize;
double sliderValue;
#endif
{
   int ac;
   Arg al[6];
   int scrollBarMinimum = (int)minimum;
   int scrollBarMaximum = (int)maximum;
   int scrollBarIncrement = (int)increment;
   int scrollBarPageIncrement = (int)pageIncrement;
   int scrollBarSliderSize = (int)sliderSize;
   int scrollBarSliderValue = (int)sliderValue;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   if((double)scrollBarMinimum > minimum)
      scrollBarMinimum--;
   if((double)scrollBarMaximum < maximum)
      scrollBarMaximum++;
   if(scrollBarIncrement == 0)
      scrollBarIncrement = 1;

   scrollBarSliderSize = MIN(scrollBarSliderSize,
                             scrollBarMaximum-scrollBarMinimum);
   if(scrollBarSliderValue+scrollBarSliderSize > scrollBarMaximum)
      scrollBarSliderValue = scrollBarMaximum-scrollBarSliderSize;

   ac = 0;
   XtSetArg(al[ac],XmNminimum,scrollBarMinimum); ac++;
   XtSetArg(al[ac],XmNmaximum,scrollBarMaximum); ac++;
   XtSetArg(al[ac],XmNincrement,scrollBarIncrement); ac++;
   XtSetArg(al[ac],XmNpageIncrement,scrollBarPageIncrement); ac++;
   XtSetArg(al[ac],XmNsliderSize,scrollBarSliderSize); ac++;
   XtSetArg(al[ac],XmNvalue,scrollBarSliderValue); ac++;
   XtSetValues(wScrollBar,al,ac);
}

static long moscrbrDefaultEventMask = -1;
static long moscrbrDefaultBackground = -1;
static long moscrbrInputMask = KeyPressMask | KeyReleaseMask |
                               ButtonPressMask | ButtonReleaseMask;

#ifdef __STDC__
void moDisableInputSB(Widget wScrollBar)
#else
void moDisableInputSB(wScrollBar)
Widget wScrollBar;
#endif
{
   Widget form;
   Pixel  background;
   long   eventMask;
   long   noInputMask = ~moscrbrInputMask;
   long   noInputEventMask;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   eventMask = moGetEventMask(wScrollBar);
   noInputEventMask = eventMask & noInputMask;
   moSetEventMask(wScrollBar,noInputEventMask);
   if(moscrbrDefaultEventMask == -1)
      moscrbrDefaultEventMask = eventMask;

   form = XtParent(wScrollBar);
   while(!XmIsForm(form) && !XmIsFileSelectionBox(form))
      form = XtParent(form);
 
   if(moscrbrDefaultBackground == -1)
      moscrbrDefaultBackground = (long)moGetBackgroundPixel(wScrollBar);

   background = moGetBackgroundPixel(form);
   moSetBackgroundPixel(wScrollBar,background);
   moSetTraversalOff(wScrollBar);
}


#ifdef __STDC__
void moEnableInputSB(Widget wScrollBar)
#else
void moEnableInputSB(wScrollBar)
Widget wScrollBar;
#endif
{
   long eventMask;
   long inputEventMask;

   assert(wScrollBar != NULL);
   assert(XmIsScrollBar(wScrollBar));

   if((moscrbrDefaultEventMask >= 0) && (moscrbrDefaultBackground >= 0)) {
      eventMask = moGetEventMask(wScrollBar);
      inputEventMask = eventMask | moscrbrInputMask;
      moSetEventMask(wScrollBar,inputEventMask);

      moSetBackgroundPixel(wScrollBar,(Pixel)moscrbrDefaultBackground);
   } else {
      if(moscrbrDefaultBackground == -1)
         moscrbrDefaultBackground = (long)moGetBackgroundPixel(wScrollBar);

      if(moscrbrDefaultEventMask == -1)
         moscrbrDefaultEventMask = moGetEventMask(wScrollBar);
   }
   moSetTraversalOn(wScrollBar);
}


