/*
   $RCSfile: moselctu.h,v $       $Revision: 1.1 $
   $State: V7_0 $                  $Date: 2002/12/06 16:32:47 $
*/
#ifndef _MOSELCTU_H
#define _MOSELCTU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Xm.h>
#include <Xm/TextF.h>

typedef enum {
   SelectMatchRequirementMust,
   SelectMatchRequirementMustNot,
   SelectMatchRequirementDontCare
} moSelectMatchRequirement;

typedef enum {
   SelectVerifyPolicyNone,
   SelectVerifyPolicyUpperCase,
   SelectVerifyPolicyName,
   SelectVerifyPolicySubstitutedName,
   SelectVerifyPolicyWildcardName,
   SelectVerifyPolicySubstitutedWildcardName,
   SelectVerifyPolicyMixedCaseName,
   SelectVerifyPolicyElementName,
   SelectVerifyPolicyWildcardElementName,
   SelectVerifyPolicyFileName,
   SelectVerifyPolicyWildcardFileName,
   SelectVerifyPolicyAlphabet,
   SelectVerifyPolicyInteger,
   SelectVerifyPolicyWildcardInteger,
   SelectVerifyPolicyPositiveInteger,
   SelectVerifyPolicyWildcardPositiveInteger,
   SelectVerifyPolicyHeaderName,
   SelectVerifyPolicyWildcardHeaderName
} moSelectVerifyPolicy;

#ifdef __STDC__
   extern void moVerifySelectInput(Widget wTextField,
                                   XmTextVerifyCallbackStruct *call_data,
                                   moSelectVerifyPolicy selectVerifyPolicy);
#else
   extern void moVerifySelectInput();
#endif

#ifdef __cplusplus
   }
#endif

#endif
