/*
  $RCSfile: mosprshp.h,v $       $Revision: 1.3 $
  $State: V7_0 $                  $Date: 2003/08/20 10:30:09 $
*/
#ifndef _MOSPRSHP_H
#define _MOSPRSHP_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Xm.h>

#define SPREADSHEETINCREMENT       0.05
#define SPREADSHEETPAGEINCREMENT   0.15

#ifdef __STDC__
   extern void XtMoveWidget(Widget w,                  /* Borrowed from <X11/IntrinsicP.h> */
                            Position x,
                            Position y);
   static void mosprshGetTableVRowColumnSize(Widget tableWidget,
                                             double *tableWidth,
                                             double *tableHeight);
   static void mosprshGetTableVisibleSize(Widget tableWidget,
                                          double *tableVisibleWidth,
                                          double *tableVisibleHeight);
   static void mosprshSetTableHorizontalScroll(Widget horizontalScrollBar);
   static void mosprshSetTableVerticalScroll(Widget verticalScrollBar);
#else
   extern void XtMoveWidget();
   static void mosprshGetTableVRowColumnSize();
   static void mosprshGetTableVisibleSize();
   static void mosprshSetTableHorizontalScroll();
   static void mosprshSetTableVerticalScroll();
#endif

#ifdef __cplusplus
   }
#endif

#endif
