/*
  $RCSfile: mosprshu.h,v $       $Revision: 1.5 $
  $State: V7_0 $                  $Date: 2003/06/27 10:32:53 $
*/
#ifndef _MOSPRSHU_H
#define _MOSPRSHU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Xm.h>

#include "uttypesu.h"
#include "utsarryu.h"
#include "uttableu.h"


#ifdef __STDC__
   extern char *moGetSpreadsheetValue(Widget parentFM,
                                       int rowNumber,
                                       int columnNumber);
   extern void moSetSpreadsheetValue(Widget parentFM,
                                     int rowNumber,
                                     int columnNumber,
                                     char *value);
   extern void moClearSpreadsheetValue(Widget parentFM,
                                       int rowNumber,
                                       int columnNumber);
   extern double moGetSpreadsheetDouble(Widget parentFM,
                                        int rowNumber,
                                        int columnNumber);
   extern void moSetSpreadsheetDouble(Widget parentFM,
                                      int rowNumber,
                                      int columnNumber,
                                      double value);
   extern int moGetSpreadsheetInt(Widget parentFM,
                                  int rowNumber,
                                  int columnNumber);
   extern void moSetSpreadsheetInt(Widget parentFM,
                                   int rowNumber,
                                   int columnNumber,
                                   int value);
   extern long moGetSpreadsheetLong(Widget parentFM,
                                    int rowNumber,
                                    int columnNumber);
   extern void moSetSpreadsheetLong(Widget parentFM,
                                    int rowNumber,
                                    int columnNumber,
                                    long value);
   extern void moSetSpreadsheetSbuttonFunction(Widget parentFM,
                                               int rowNumber,
                                               int columnNumber,
                                               utLogical editable,
                                               char *sButtonFunction);
   extern void moAddSpreadsheetVchgCallback(Widget parentFM,
                                            int rowNumber,
                                            int columnNumber,
                                            void valueChangedCallback(Widget w,
                                                                      XtPointer client_data,
                                                                      XtPointer xt_call_data));
   extern void moDisableSpreadsheetInput(Widget parentFM,
                                         int rowNumber,
                                         int columnNumber);
   extern void moEnableSpreadsheetInput(Widget parentFM,
                                        int rowNumber,
                                        int columnNumber);
   extern pSarray moGetSpreadsheetFixedRowNames(Widget parentFM);
   extern void moSetSpreadsheetFixedRowNames(Widget parentFM,
                                             pSarray columnNames);
   extern pSarray moGetSpreadsheetFixColumnNames(Widget parentFM);
   extern void moSetSpreadsheetFixColumnNames(Widget parentFM,
                                              pSarray rowNames);
   extern void moSetSpreadsheetScrollBars(Widget parentFM);
   extern void moDisableSpreadsheetRowInput(Widget parentFM,
                                            int rowNumber);
   extern void moDisableSpreadsheetColumnInput(Widget parentFM,
                                               int columnNumber);
   extern void moBuildSpreadsheetFromTable(Widget parentFM,
                                           char *spreadSheetTitle,
                                           pTable table,
                                           char *ignoreValue,
                                           void mosprshCheckButtonCallback(Widget w,
                                                                           XtPointer client_data,
                                                                           XtPointer xt_call_data));
   extern pTable moGetTableFromSpreadsheet(Widget parentFM,
                                           utLogical stripNames);
   extern void moDisableSpreadsheetTableInput(Widget parentFM,
                                              pTable table,
                                              char *ignoreValue);
   extern void moGetSpreadsheetTFRowAndColumn(Widget textField,
                                              int *rowNumber,
                                              int *columnNumber);
   extern char *moGetSpreadsheetColumnName(Widget parentFM,
                                           int columnNumber);
   extern char *moGetSpreadsheetRowName(Widget parentFM,
                                        int rowNumber);
   extern void moSetSpreadsheetInsensitive(Widget parentFM,
                                           int rowNumber,
                                           int columnNumber);
   extern void moSetSpreadsheetSensitive(Widget parentFM,
                                         int rowNumber,
                                         int columnNumber);
#else
   extern char *moGetSpreadsheetValue();
   extern void moSetSpreadsheetValue();
   extern void moClearSpreadsheetValue();
   extern double moGetSpreadsheetDouble();
   extern void moSetSpreadsheetDouble();
   extern int moGetSpreadsheetInt();
   extern void moSetSpreadsheetInt();
   extern int moGetSpreadsheetLong();
   extern void moSetSpreadsheetLong();
   extern void moSetSpreadsheetSbuttonFunction();
   extern void moAddSpreadsheetVchgCallback();
   extern void moDisableSpreadsheetInput();
   extern void moEnableSpreadsheetInput();
   extern pSarray moGetSpreadsheetFixedRowNames();
   extern void moSetSpreadsheetFixedRowNames();
   extern pSarray moGetSpreadsheetFixColumnNames();
   extern void moSetSpreadsheetFixColumnNames();
   extern void moSetSpreadsheetScrollBars();
   extern void moDisableSpreadsheetRowInput();
   extern void moDisableSpreadsheetColumnInput();
   extern void moBuildSpreadsheetFromTable();
   extern pTable moGetTableFromSpreadsheet();
   extern void moDisableSpreadsheetTableInput();
   extern void moGetSpreadsheetTFRowAndColumn();
   extern char *moGetSpreadsheetColumnName();
   extern char *moGetSpreadsheetRowName();
   extern void moSetSpreadsheetInsensitive();
   extern void moSetSpreadsheetSensitive();
#endif

#ifdef __cplusplus
   }
#endif

#endif
