/*
  $RCSfile: motextw.h,v $       $Revision: 1.6 $
  $State: V7_0 $                  $Date: 2002/12/06 16:25:29 $
*/
#ifndef _MOTEXTW_H
#define _MOTEXTW_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Text.h>

#include "uttypesu.h"

#ifdef __STDC__
   extern char      *moGetCstringFromTX(Widget wText);
   extern void       moSetCstringToTX(Widget wText,
                                      char* s);
   extern void       moCopyToCstringFromTX(Widget wText,
                                           char* s,
                                           int bufSize);
   extern void       moClearTX(Widget wText);
   extern void       moSetEditableTX(Widget wText);
   extern void       moSetUneditableTX(Widget wText);
   extern void       moSetCursorVisibleOnTX(Widget wText);
   extern void       moSetCursorVisibleOffTX(Widget wText);
   extern int        moGetMaxLengthTX(Widget wText);
   extern void       moSetMaxLengthTX(Widget wText,
                                      int maxLength);
   extern void       moDisableInputTX(Widget wText);
   extern void       moEnableInputTX(Widget wText);
   extern utLogical  moIsEditableTX(Widget wText);
   extern void       moUnderlineStringTX(Widget wText,
                                         int startPosition,
                                         int endPosition);
   extern char      *moGetSelectionTX(Widget wText);
   extern utLogical  moIsEmptyTX(Widget wText);
   extern int        moGetNumberOfColumnsTX(Widget wText);
   extern void       moSetNumberOfColumnsTX(Widget wText,
                                            int numberOfColumns);
   extern int        moGetNumberOfRowsTX(Widget wText);
   extern void       moSetNumberOfRowsTX(Widget wText,
                                         int numberOfRows);
#else
   extern char      *moGetCstringFromTX();
   extern void       moSetCstringToTX();
   extern void       moCopyToCstringFromTX();
   extern void       moClearTX();
   extern void       moSetEditableTX();
   extern void       moSetUneditableTX();
   extern void       moSetCursorVisibleOnTX();
   extern void       moSetCursorVisibleOffTX();
   extern int        moGetMaxLengthTX();
   extern void       moSetMaxLengthTX();
   extern void       moDisableInputTX();
   extern void       moEnableInputTX();
   extern utLogical  moIsEditableTX();
   extern void       moUnderlineStringTX();
   extern char      *moGetSelectionTX();
   extern utLogical  moIsEmptyTX();
   extern int        moGetNumberOfColumnsTX();
   extern void       moSetNumberOfColumnsTX();
   extern int        moGetNumberOfRowsTX();
   extern void       moSetNumberOfRowsTX();
#endif

#ifdef __cplusplus
   }
#endif

#endif
