#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Separator.h>
#include <Xm/TextF.h>
#include <Xm/ToggleBG.h>


static Widget xd_links [ 1 ];

extern void XDmanage_link ( Widget w, XtPointer client_data, XtPointer call_data );
extern void XDunmanage_link ( Widget w, XtPointer client_data, XtPointer call_data );
extern void XDpopup_link ( Widget w, XtPointer client_data, XtPointer call_data );
extern void XDpopdown_link ( Widget w, XtPointer client_data, XtPointer call_data );
extern void XDmap_link ( Widget w, XtPointer client_data, XtPointer call_data );
extern void XDunmap_link ( Widget w, XtPointer client_data, XtPointer call_data );
extern void XDenable_link ( Widget w, XtPointer client_data, XtPointer call_data );
extern void XDdisable_link ( Widget w, XtPointer client_data, XtPointer call_data );

Widget vttmodalDB = (Widget) NULL;
Widget vttmodalFM = (Widget) NULL;

void create_vttmodalDB (Widget parent)
{
	Widget children[8];      /* Children to manage */
	Arg al[64];                    /* Arg List */
	register int ac = 0;           /* Arg Count */
	XmString xmstrings[16];    /* temporary storage for XmStrings */

	XtSetArg(al[ac], XmNallowShellResize, TRUE); ac++;
	XtSetArg(al[ac], XmNtitle, "Outer Box"); ac++;
	vttmodalDB = XmCreateDialogShell ( parent, "vttmodalDB", al, ac );
	ac = 0;
	XtSetArg(al[ac], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); ac++;
	XtSetArg(al[ac], XmNautoUnmanage, FALSE); ac++;
	vttmodalFM = XmCreateForm ( vttmodalDB, "vttmodalFM", al, ac );
	ac = 0;
        XtManageChildren(children, ac);
        ac = 0;
}

