/*
  $RCSfile: utlistpp.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:38:36 $
*/
#ifndef _UTLISTPP_H
#define _UTLISTPP_H

#ifdef __cplusplus
   extern "C" {
#endif

#ifdef __STDC__
   static void utInitializeListOfPtrs(pListOfPtrs list,
                                      int nBlockSize);
   static void utFreeDataChainListOfPtrs(CPlex_P* p);
   static CNode_P* utCreateNewBlockListOfPtrs(pListOfPtrs list);
   static CNode_P* utNewNodeListOfPtrs(pListOfPtrs list, 
                                       CNode_P* pPrev,
                                       CNode_P* pNext);
   static void utFreeNodeListOfPtrs(pListOfPtrs list,
                                    CNode_P* pNode);
#else
   static void utInitializeListOfPtrs();
   static void utFreeDataChainListOfPtrs();
   static CNode_P* utCreateNewBlockListOfPtrs();
   static CNode_P* utNewNodeListOfPtrs();
   static void utFreeNodeListOfPtrs();
#endif

#ifdef __cplusplus
   }
#endif

#endif
