/*
  $RCSfile: utstckpu.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:39:29 $
*/
#ifndef _UTSTCKPU_H
#define _UTSTCKPU_H

#ifdef __cplusplus
   extern "C" {
#endif

#define STRUCTTYPE_STACKOFPTRS 1048

#include "utlistpu.h"

typedef struct {
   int          StructType;
   pListOfPtrs  m_pList;
} StackOfPtrs, *pStackOfPtrs;
 
#ifdef __STDC__
   extern pStackOfPtrs utCreateStackOfPtrs();
   extern void utDestroyStackOfPtrs(pStackOfPtrs stack);
   extern void utPushStackOfPtrs(pStackOfPtrs stack,pVoid newElement);
   extern pVoid utPopStackOfPtrs(pStackOfPtrs stack);
   extern void utEmptyStackOfPtrs(pStackOfPtrs stack);
   extern pVoid utShowNextStackOfPtrs(pStackOfPtrs stack);
   extern int utSizeOfStackOfPtrs(pStackOfPtrs stack);
   extern int utIsEmptyStackOfPtrs(pStackOfPtrs stack);
#else
   extern pStackOfPtrs utCreateStackOfPtrs();
   extern void utDestroyStackOfPtrs();
   extern void utPushStackOfPtrs();
   extern pVoid utPopStackOfPtrs();
   extern void utEmptyStackOfPtrs();
   extern pVoid utShowNextStackOfPtrs();
   extern int utSizeOfStackOfPtrs();
   extern int utIsEmptyStackOfPtrs();
#endif

#ifdef __cplusplus
   }
#endif

#endif
