/*
  $RCSfile: utsysclu.h,v $       $Revision: 1.7 $
  $State: V7_0 $                  $Date: 2004/07/27 10:06:12 $
*/
#ifndef _UTSYSCLU_H
#define _UTSYSCLU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include "uttypesu.h"

#ifdef BPTUNIX
#define RAWSTATUS utFalse
#endif
#ifdef BPTVMS
#define RAWSTATUS utTrue
#endif
#ifdef BPTPC
#define RAWSTATUS utFalse
#define STATUSCODEFILENAME        "statusCode"
#define STATUSCODEFILEEXTENSION   "dat"
#endif

#ifdef BPTUNIX
#define BATCHESDIRECTORY            "batches"
#define BAT_VERSIONPREFIX           "versn"
#define BAT_DATADIRECTORY           "data"
#define BAT_DTESTDIRECTORY          "dtest"
#define BAT_EXAMPLESDIRECTORY       "EXAMPLES"
#define BAT_EXECSDIRECTORY          "execs"
#define BAT_LIBSDIRECTORY           "libs"
#define BAT_SOURCEDIRECTORY         "source"
#define BAT_PROPERTYDATADIRECTORY   "Property"
#endif
#ifdef BPTVMS
#define BATCHESDIRECTORY            "BATCHES"
#define BAT_VERSIONPREFIX           "VERSN"
#define BAT_DATADIRECTORY           "DATA"
#define BAT_DTESTDIRECTORY          "DTEST"
#define BAT_EXAMPLESDIRECTORY       "EXAMPLES"
#define BAT_EXECSDIRECTORY          "EXECS"
#define BAT_LIBSDIRECTORY           "LIBS"
#define BAT_SOURCEDIRECTORY         "SOURCE"
#define BAT_PROPERTYDATADIRECTORY   "PROPERTY"
#endif
#ifdef BPTPC
#define BATCHESDIRECTORY            "batches"
#define BAT_VERSIONPREFIX           "versn"
#define BAT_DATADIRECTORY           "data"
#define BAT_DTESTDIRECTORY          "dtest"
#define BAT_EXAMPLESDIRECTORY       "EXAMPLES"
#define BAT_EXECSDIRECTORY          "execs"
#define BAT_LIBSDIRECTORY           "libs"
#define BAT_SOURCEDIRECTORY         "source"
#define BAT_PROPERTYDATADIRECTORY   "Property"
#endif

#ifdef __STDC__
   extern int utSystemCall(char *systemCommand,
                           utLogical background,
                           utLogical rawstatus,
                           char *statusCodePath);
   extern char *utGetEnvironmentVariable(char *variableName);
   extern char *utGetBPT_ROOTPath();
   extern char *utGetBAT_VERSN();
   extern void utSetBAT_VERSN(char *version);
   extern char *utGetBAT_VERSNPath();
   extern char *utGetBAT_DATAPath();
   extern char *utGetBAT_DATAForLicensePath();
   extern char *utGetBAT_DTESTPath();
   extern char *utGetBAT_EXAMPLESPath();
   extern char *utGetBAT_EXECSPath();
   extern char *utGetBAT_LIBSPath();
   extern char *utGetBAT_SOURCEPath();
   extern char *utGetBAT_PROPERTYDATAPath();
   extern char *utGetCommandPath(char *command);
#else
   extern int utSystemCall();
   extern char *utGetEnvironmentVariable();
   extern char *utGetBPT_ROOTPath();
   extern char *utGetBAT_VERSN();
   extern void utSetBAT_VERSN();
   extern char *utGetBAT_VERSNPath();
   extern char *utGetBAT_DATAPath();
   extern char *utGetBAT_DATAForLicensePath();
   extern char *utGetBAT_DTESTPath();
   extern char *utGetBAT_EXAMPLESPath();
   extern char *utGetBAT_EXECSPath();
   extern char *utGetBAT_LIBSPath();
   extern char *utGetBAT_SOURCEPath();
   extern char *utGetBAT_PROPERTYDATAPath();
   extern char *utGetCommandPath();
#endif

#ifdef __cplusplus
   }
#endif

#endif
