/*
  $RCSfile: moclrslc.c,v $       $Revision: 1.4 $
  $State: V7_0 $                  $Date: 2003/10/01 14:03:35 $
*/
#include "utmacrou.h"
#include "utstrngu.h"
#include "utmemryu.h"

#include "moclrslc.h"
#include "moclrslu.h"
#include "momotifu.h"
#include "modefltw.h"
#include "motextfw.h"
#include "molistw.h"
#include "momessgc.h"
#include "moclocku.h"

#include "moclrslx.xh"

static utLogical moclrslExitOK;

#ifdef __STDC__
char *moclrslInitDB(Widget parent,
                    Widget wTextField,
                    utLogical editable,
                    char *initialColor)
#else
char *moclrslInitDB(parent,
                    wTextField,
                    editable,
                    initialColor)
Widget     parent;
Widget     wTextField; 
utLogical  editable;
char      *initialColor;
#endif
{
   char    *returnColor = NULL;
/*
   pSarray  colors;
   char    *color;

   create_vmoclrslDB(parent);
   moClockAddWidget(vmoclrslDB);

   colors = moGetColors();
   moLoadSarrayToLS(vmoclrslSeleLS,colors);      

   moClearTF(vmoclrslSlctTF);

   XtManageChild(vmoclrslFM);

   if(editable)
      moEnableInputTF(vmoclrslSlctTF);
   else
      moDisableInputTF(vmoclrslSlctTF);

   if       (!utIsNullString(initialColor)) {
      moSelectItemInLS(vmoclrslSeleLS,initialColor);
   } else if(wTextField != NULL) {
      color = moGetCstringFromTF(wTextField);
      if(!utIsNullString(color))
         moSelectItemInLS(vmoclrslSeleLS,color);
      utFreeBytes((pVoid)color);
   }

   moclrslExitOK = utFalse;
   moWaitWhileManaged(vmoclrslFM);

   if(moclrslExitOK) {
      returnColor = moGetCstringFromTF(vmoclrslSlctTF);
      if(wTextField != NULL)
         moSetCstringToTF(wTextField,returnColor);
   }

   moClockDeleteWidget(vmoclrslDB);
   XtDestroyWidget(vmoclrslDB);

*/
   return(returnColor);
}


#ifdef __STDC__
void moclrslBrowSeleLS(Widget w,
                       XtPointer client_data,
                       XmListCallbackStruct *call_data)
#else
void moclrslBrowSeleLS(w,
                       client_data,
                       call_data)
Widget w;
XtPointer client_data;
XmListCallbackStruct *call_data;
#endif
{
   char            *color = WHITE;
   ColorIdentifier  colorIdentifier;
   char            *errorMessage;
   Pixel            background = moGetBackgroundPixel(moGetParentDialogShell(w));
 
   colorIdentifier = moGetColorIdentifier(color);
}


#ifdef __STDC__
void moclrslActOkPB(Widget w,
                    XtPointer client_data,
                    XmAnyCallbackStruct *call_data)
#else
void moclrslActOkPB(w,
                    client_data,
                    call_data)
Widget w;
XtPointer client_data;
XmAnyCallbackStruct *call_data;
#endif
{
   utLogical isColorNotSpecified = utTrue;
 
}


#ifdef __STDC__
void moSbuttonColor(Widget w,
                    XEvent *event,
                    String *parameters,
                    Cardinal *nParameters)
#else
void moSbuttonColor(w,
                    event,
                    parameters,
                    nParameters)
Widget    w;
XEvent   *event;
String   *parameters;
Cardinal *nParameters;
#endif
{
   char *newColor = moclrslInitDB(moGetParentDialogShell(w),
                                  w,
                                  utFalse,
                                  NULL);
   utFreeBytes((pVoid)newColor);
}


