/*
  $RCSfile: moclrslu.h,v $       $Revision: 1.4 $
  $State: V7_0 $                  $Date: 2003/10/01 14:03:39 $
*/
#ifndef _MOCLRSLU_H
#define _MOCLRSLU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Xm.h>

#include "uttypesu.h"
#include "utsarryu.h"

typedef long ColorIdentifier;
#define NOCOLORID ((ColorIdentifier)-1)

#define COLORSFILENAME       "colors"
#define COLORSFILEEXTENSION  "dat"

#define ANTIQUEWHITE       "AntiqueWhite"
#define BLACK              "Black"
#define BLUE               "Blue"
#define CYAN               "Cyan"
#define DEEPSKYBLUE        "DeepSkyBlue"
#define GREEN              "Green"
#define HOLLOW             "Hollow"
#define LIGHTGRAY          "LightGray"
#define MAGENTA            "Magenta"
#define MEDIUMAQUAMARINE   "MediumAquamarine"
#define PINK               "Pink"
#define RED                "Red"
#define WHEAT              "Wheat"
#define WHITE              "White"
#define YELLOW             "Yellow"

#ifdef __STDC__
   extern utLogical        moLoadColorData();
   extern void             moFreeColorData();
   extern pSarray          moGetColors();
   extern char            *moGetColor(ColorIdentifier colorIdentifier);
   extern ColorIdentifier  moGetColorIdentifier(char *color);
   extern void             moGetColorIdentifierRGB(ColorIdentifier colorIdentifier,
                                                   int *red,
                                                   int *green,
                                                   int *blue);
   extern int              moGetMaxColorRGBValue();
   extern void             moSetMaxColorRGBValue();
#else
   extern utLogical        moLoadColorData();
   extern void             moFreeColorData();
   extern pSarray          moGetColors();
   extern char            *moGetColor();
   extern ColorIdentifier  moGetColorIdentifier();
   extern void             moGetColorIdentifierRGB();
   extern int              moGetMaxColorRGBValue();
   extern void             moSetMaxColorRGBValue();
#endif

#ifdef __cplusplus
   }
#endif

#endif
