/*
  $RCSfile: momotifu.h,v $       $Revision: 1.15 $
  $State: V7_1 $                  $Date: 2004/10/25 10:45:11 $
*/
#ifndef _MOMOTIFU_H
#define _MOMOTIFU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdio.h>

#include <Xm/Xm.h>

#include "uttypesu.h"

#ifdef __STDC__
   extern void moWaitWhileManaged();
   extern void moDestroyManagedParentStack();
   extern void moManageWithControl(Widget w);
   extern void moSetSensitive(Widget w);
   extern void moSetInsensitive(Widget w);
   extern utLogical moIsSensitive(Widget w);
   extern void moSetTitleOfDB(Widget wDB,
                              char* title);
   extern Pixel moGetForegroundPixel(Widget w);
   extern void moSetForegroundPixel(Widget w,
                                    Pixel fg);
   extern Pixel moGetBackgroundPixel(Widget w);
   extern void moSetBackgroundPixel(Widget w,
                                    Pixel bg);
   extern void moGetSizeOfWidget(Widget w,
                                 double *width,
                                 double *height);
   extern void moSetSizeOfWidget(Widget w,
                                 double width,
                                 double height);
   extern void moGetLocationOfWidget(Widget w,
                                     double *xLeft,
                                     double *yTop);
   extern void moSetLocationOfWidget(Widget w,
                                     double xLeft,
                                     double yTop);
   extern Widget moGetParentDialogShell(Widget w);
   extern void moGetSizeOfDialogShellParent(Widget w,
                                            double *width,
                                            double *height);
   extern void moGetLocatOfDialogShellParent(Widget w,
                                             double *xLeft,
                                             double *yTop);
   extern double moGetScreenWidth();
   extern double moGetScreenHeight();
   extern void moSetEditFunctionBtnSensitivity(Widget list,
                                               Widget addButton,
                                               Widget insertButton,
                                               Widget changeButton,
                                               Widget deleteButton,
                                               Widget copyButton,
                                               Widget pasteButton,
                                               Widget textField1,
                                               Widget textField2,
                                               Widget textField3,
                                               Widget textField4,
                                               Widget textField5,
                                               Widget textField6,
                                               Widget choiceList,
                                               Widget flagSelectionList,
                                               pVoid clipBoard);
   extern void moSetEditFileFuncBtnSensitivity(Widget list,
                                               Widget addFileButton,
                                               Widget insertFileButton,
                                               Widget textField1,
                                               Widget textField2,
                                               Widget textField3,
                                               Widget textField4,
                                               Widget textField5,
                                               Widget textField6,
                                               Widget choiceList,
                                               Widget flagSelectionList);
   extern long moGetEventMask(Widget w);
   extern void moSetEventMask(Widget w,
                              long eventMask);
   extern void moPrintEventMask(FILE *fp,
                                long eventMask);
   extern void moSetTraversalOn(Widget w);
   extern void moSetTraversalOff(Widget w);
   extern void moSetWidgetFont(Widget w,
                               char *fontName);
   extern char *moGetWidgetName(Widget w);
   extern void moRingBell();
   extern char *moGetResourceValue(char *programName,
                                   char *resourceName);
   extern void moSetErrorHandler();
   extern void moProcessExposeEvents();
   extern void moProcessStructureNotifyEvents();
   extern void moHorizontallyCenterWidgetInFM(Widget w);
   extern void moVerticallyCenterWidgetInFM(Widget w);
   extern double moGetLeftOffset(Widget w);
   extern void moSetLeftOffset(Widget w,
                               double widgetOffsetLeft);
   extern double moGetRightOffset(Widget w);
   extern void moSetRightOffset(Widget w,
                                double widgetOffsetRight);
   extern double moGetTopOffset(Widget w);
   extern void moSetTopOffset(Widget w,
                              double widgetOffsetTop);
   extern double moGetBottomOffset(Widget w);
   extern void moSetBottomOffset(Widget w,
                                 double widgetOffsetBottom);
   extern void moSwitchMouseButtons2and3();
   extern void moPrintWidgetClass(Widget w);
   extern void moDestroyWidgetChildren(Widget w);
   extern void moDisableInput(Widget w);
   extern void moEnableInput(Widget w);
#else
   extern void moWaitWhileManaged();
   extern void moDestroyManagedParentStack();
   extern void moManageWithControl();
   extern void moSetSensitive();
   extern void moSetInsensitive();
   extern utLogical moIsSensitive();
   extern void moSetTitleOfDB();
   extern Pixel moGetForegroundPixel();
   extern void moSetForegroundPixel();
   extern Pixel moGetBackgroundPixel();
   extern void moSetBackgroundPixel();
   extern void moGetSizeOfWidget();
   extern void moSetSizeOfWidget();
   extern void moGetLocationOfWidget();
   extern void moSetLocationOfWidget();
   extern Widget moGetParentDialogShell();
   extern void moGetSizeOfDialogShellParent();
   extern void moGetLocatOfDialogShellParent();
   extern double moGetScreenWidth();
   extern double moGetScreenHeight();
   extern void moSetEditFunctionBtnSensitivity();
   extern void moSetEditFileFuncBtnSensitivity();
   extern long moGetEventMask();
   extern void moSetEventMask();
   extern void moPrintEventMask();
   extern void moSetTraversalOn();
   extern void moSetTraversalOff();
   extern void moSetWidgetFont();
   extern char *moGetWidgetName();
   extern void moRingBell();
   extern char *moGetResourceValue();
   extern void moSetErrorHandler();
   extern void moProcessExposeEvents();
   extern void moProcessStructureNotifyEvents();
   extern void moHorizontallyCenterWidgetInFM();
   extern void moVerticallyCenterWidgetInFM();
   extern double moGetLeftOffset();
   extern void moSetLeftOffset();
   extern double moGetRightOffset();
   extern void moSetRightOffset();
   extern double moGetTopOffset();
   extern void moSetTopOffset();
   extern double moGetBottomOffset();
   extern void moSetBottomOffset();
   extern void moSwitchMouseButtons2and3();
   extern void moPrintWidgetClass();
   extern void moDestroyWidgetChildren();
   extern void moDisableInput();
   extern void moEnableInput();
#endif

#ifdef __cplusplus
   }
#endif

#endif
