/*
  $RCSfile: mosbutnu.h,v $       $Revision: 1.5 $
  $State: V7_0 $                  $Date: 2003/05/08 17:09:45 $
*/
#ifndef _MOSBUTNU_H
#define _MOSBUTNU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Xm.h>

#include "uttypesu.h"
#include "utsarryu.h"

#include "moclrslu.h"

#define STRUCTTYPE_SBUTTONFUNCTIONPARAMETERS 3002

typedef struct {
   int           StructType;
   Widget        Field;
   utLogical     FieldIsBlankable;
   char         *SButtonFunction;
   XtActionProc  ActionFunction;
   pSarray       Parameters;
} SButtonFunctionParameters, *pSButtonFunctionParameters;

#ifdef __STDC__
   extern void moSbuttonInitializeActions();
   extern void moRegisterSbuttonFunctions(XtActionList actionList,
                                          Cardinal nActions);
   extern pSButtonFunctionParameters moCreateSButtonFunctParameters(Widget field,
                                                                    char *sButtonFunction);
   extern void moFreeSButtonFunctionParameters(pSButtonFunctionParameters *sButtonFunctionParameters);
   extern void moAddSButtonFuncParameterToList(pSButtonFunctionParameters sButtonFunctionParameters);
   extern void moRemoveSBtnFuncParamFromList(pSButtonFunctionParameters sButtonFunctionParameters);
   extern void moDestroySButtonFunctionLists();
   extern void moSetTextFieldSbuttonFunction(Widget textField,
                                             utLogical editable,
                                             char *sButtonFunction);
   extern void moResetTextFieldSbuttonFunction(Widget textField,
                                               utLogical editable,
                                               char *sButtonFunction);
   extern utLogical moIsSbuttonWidget(Widget w);
   extern ColorIdentifier moGetSbuttonColorIdentifier();
   extern void moSetListSbuttonFunction(Widget list,
                                        char *sButtonFunction);
   extern void moSetSbuttonWidgetBlankability(Widget w,
                                              utLogical isBlankable);
#else
   extern void moSbuttonInitializeActions();
   extern void moRegisterSbuttonFunctions();
   extern pSButtonFunctionParameters moCreateSButtonFunctParameters();
   extern void moFreeSButtonFunctionParameters();
   extern void moAddSButtonFuncParameterToList();
   extern void moRemoveSBtnFuncParamFromList();
   extern void moDestroySButtonFunctionLists();
   extern void moSetTextFieldSbuttonFunction();
   extern void moResetTextFieldSbuttonFunction();
   extern utLogical moIsSbuttonWidget();
   extern ColorIdentifier moGetSbuttonColorIdentifier();
   extern void moSetListSbuttonFunction();
   extern void moSetSbuttonWidgetBlankability();
#endif

#ifdef __cplusplus
   }
#endif

#endif
