/*
  $RCSfile: moscrbrw.h,v $       $Revision: 1.3 $
  $State: V7_1 $                  $Date: 2004/10/25 10:45:14 $
*/
#ifndef _MOSCRBRW_H
#define _MOSCRBRW_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/ScrollBar.h>

#ifdef __STDC__
   extern void moGetMinimumSB(Widget wScrollBar,
                              double *minimum);
   extern void moSetMinimumSB(Widget wScrollBar,
                              double minimum);
   extern void moGetMaximumSB(Widget wScrollBar,
                              double *maximum);
   extern void moSetMaximumSB(Widget wScrollBar,
                              double maximum);
   extern void moGetIncrementSB(Widget wScrollBar,
                                double *increment);
   extern void moSetIncrementSB(Widget wScrollBar,
                                double increment);
   extern void moGetPageIncrementSB(Widget wScrollBar,
                                    double *pageIncrement);
   extern void moSetPageIncrementSB(Widget wScrollBar,
                                    double pageIncrement);
   extern void moGetSliderSizeSB(Widget wScrollBar,
                                 double *sliderSize);
   extern void moSetSliderSizeSB(Widget wScrollBar,
                                 double sliderSize);
   extern void moGetSliderValueSB(Widget wScrollBar,
                                  double *sliderValue);
   extern void moSetSliderValueSB(Widget wScrollBar,
                                  double sliderValue);
   extern void moSetValuesSB(Widget wScrollBar,
                             double minimum,
                             double maximum,
                             double increment,
                             double pageIncrement,
                             double sliderSize,
                             double sliderValue);
   extern void moDisableInputSB(Widget wScrollBar);
   extern void moEnableInputSB(Widget wScrollBar);
#else
   extern void moGetMinimumSB();
   extern void moSetMinimumSB();
   extern void moGetMaximumSB();
   extern void moSetMaximumSB();
   extern void moGetIncrementSB();
   extern void moSetIncrementSB();
   extern void moGetPageIncrementSB();
   extern void moSetPageIncrementSB();
   extern void moGetSliderSizeSB();
   extern void moSetSliderSizeSB();
   extern void moGetSliderValueSB();
   extern void moSetSliderValueSB();
   extern void moSetValuesSB();
   extern void moDisableInputSB();
   extern void moEnableInputSB();
#endif

#ifdef __cplusplus
   }
#endif

#endif
