/*
  $RCSfile: mosprshx.h,v $       $Revision: 1.5 $
  $State: V7_0 $                  $Date: 2003/06/27 10:06:58 $
*/
#ifndef _MOSPRSHX_H
#define _MOSPRSHX_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/Xm.h>

#include "uttypesu.h"
#include "utsarryu.h"

#define STRUCTTYPE_SPREADSHEETSIZE 3004

typedef struct {
   int StructType;
   int Nrows;
   int Ncolumns;
} SpreadSheetSize, *pSpreadSheetSize;

#ifdef __STDC__
   extern void moCreateSpreadsheet(Widget parentFM,
                                   char *spreadSheetTitle,
                                   pSarray rowNames,
                                   pSarray columnNames,
                                   void mosprshCheckButtonCallback(Widget w,
                                                                   XtPointer client_data,
                                                                   XtPointer xt_call_data));
   extern void moCreateSpreadsheetWithCellSize(Widget parentFM,
                                               char *spreadSheetTitle,
                                               pSarray rowNames,
                                               pSarray columnNames,
                                               int cellSize,
                                               void mosprshCheckButtonCallback(Widget w,
                                                                               XtPointer client_data,
                                                                               XtPointer xt_call_data));
   extern void moDestroySpreadsheet(Widget parentFM);
   extern Widget moGetSpreadsheetForm(Widget parentFM);
   extern void moManageSpreadsheet(Widget parentFM);
   extern void moUnmanageSpreadsheet(Widget parentFM);
   extern utLogical moIsSpreadsheetManaged(Widget parentFM);
   extern void moGetSpreadsheetNrowAndNcolumn(Widget parentFM,
                                              int *nRows,
                                              int *nColumns);
   extern char *moGetSpreadsheetFont();
#else
   extern void moCreateSpreadsheet();
   extern void moCreateSpreadsheetWithCellSize();
   extern void moDestroySpreadsheet();
   extern Widget moGetSpreadsheetForm();
   extern void moManageSpreadsheet();
   extern void moUnmanageSpreadsheet();
   extern utLogical moIsSpreadsheetManaged();
   extern void moGetSpreadsheetNrowAndNcolumn();
   extern char *moGetSpreadsheetFont();
#endif

#ifdef __cplusplus
   }
#endif

#endif
