/*
   $RCSfile: motextfw.h,v $       $Revision: 1.9 $
   $State: V7_0 $                  $Date: 2003/06/27 10:33:01 $
*/
#ifndef _MOTEXTFW_H
#define _MOTEXTFW_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/TextF.h>

#include "uttypesu.h"

#ifdef __STDC__
   extern void moClearTF(Widget wTextField);
   extern void moSetCstringToTF(Widget wTextField,
                                char *string);
   extern void moCopyToCstringFromTF(Widget wTextField,
                                     char *buf,
                                     int bufSize);
   extern char *moGetCstringFromTF(Widget wTextField);
   extern void moSetIntToTF(Widget wTextField,
                            int value);
   extern void moSetLongToTF(Widget wTextField,
                             long value);
   extern void moSetDoubleToTF(Widget wTextField,
                               double value);
   extern void moSetEditableTF(Widget wTextField);
   extern void moSetUneditableTF(Widget wTextField);
   extern utLogical moIsEditableTF(Widget wTextField);
   extern void moShowLastPositionTF(Widget wTextField);
   extern int moGetMaxLengthTF(Widget wTextField);
   extern void moSetMaxLengthTF(Widget wTextField,
                                int maxLength);
   extern void moSetCursorVisibleOnTF(Widget wTextField);
   extern void moSetCursorVisibleOffTF(Widget wTextField);
   extern utLogical moIsCursorVisibleTF(Widget wTextField);
   extern utLogical moIsEmptyTF(Widget wTextField);
   extern void moDisableInputTF(Widget wTextField);
   extern void moEnableInputTF(Widget wTextField);
   extern void moSetNumberOfColumnsTF(Widget wTextField,
                                      int numberOfColumns);
   extern int moGetNumberOfColumnsTF(Widget wTextField);
   extern void moAddTextFieldVchgCallback(Widget wTextField,
                                          void valueChangedCallback(Widget w,
                                                                    XtPointer client_data,
                                                                    XtPointer xt_call_data));
#else
   extern void moClearTF();
   extern void moSetCstringToTF();
   extern void moCopyToCstringFromTF();
   extern char *moGetCstringFromTF();
   extern void moSetIntToTF();
   extern void moSetLongToTF();
   extern void moSetDoubleToTF();
   extern void moSetEditableTF();
   extern void moSetUneditableTF();
   extern utLogical moIsEditableTF();
   extern void moShowLastPositionTF();
   extern int moGetMaxLengthTF();
   extern void moSetMaxLengthTF();
   extern void moSetCursorVisibleOnTF();
   extern void moSetCursorVisibleOffTF();
   extern utLogical moIsCursorVisibleTF();
   extern utLogical moIsEmptyTF();
   extern void moDisableInputTF();
   extern void moEnableInputTF();
   extern void moSetNumberOfColumnsTF();
   extern int moGetNumberOfColumnsTF();
   extern void moAddTextFieldVchgCallback();
#endif

#ifdef __cplusplus
   }
#endif

#endif
