/*
  $RCSfile: utlistip.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:38:29 $
*/
#ifndef _UTLISTIP_H
#define _UTLISTIP_H

#ifdef __cplusplus
   extern "C" {
#endif

/* Implementation functions */

#ifndef __STDC__
   static void utInitializeListOfInts();
   static void utFreeDataChainListOfInts();
   static CNode_I* utCreateNewBlockListOfInts();
   static CNode_I* utNewNodeListOfInts();
   static void utFreeNodeListOfInts();
#else
   static void utInitializeListOfInts(pListOfInts list, int nBlockSize);
   static void utFreeDataChainListOfInts(CPlex_I* p);
   static CNode_I* utCreateNewBlockListOfInts(pListOfInts list);
   static CNode_I* utNewNodeListOfInts(pListOfInts list, 
                                       CNode_I* pPrev, CNode_I* pNext);
   static void utFreeNodeListOfInts(pListOfInts list, CNode_I* pNode);
#endif

#ifdef __cplusplus
   }
#endif

#endif
