/*
  $RCSfile: utmacrou.h,v $       $Revision: 1.3 $
  $State: V7_1 $                  $Date: 2004/11/03 16:18:14 $
*/
#ifndef _UTMACROU_H
#define _UTMACROU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>

#ifdef NDEBUG
#define ASSERT(ex,s)
#else
#define ASSERT(ex,s)  { (void)fprintf(stderr,s); assert(ex); }
#endif

#define MAX_PATH_LENGTH      1024
#define MAX_COMMAND_LENGTH   MAX_PATH_LENGTH+128
#define MAX_STRING_LENGTH    1000

#define utNumber(arr) ((size_t) (sizeof(arr) / sizeof(arr[0])))

#define MAX_DOUBLE_STRING_DIGITS         25
#define MAX_INTEGER_STRING_DIGITS        12
#define LARGESTDOUBLE                 1.e30

#ifdef MIN
#undef MIN
#endif
#define MIN(a,b) (((a)<(b))?(a):(b))

#ifdef MAX
#undef MAX
#endif
#define MAX(a,b) (((a)>(b))?(a):(b))

#ifndef M_PI
#define	M_PI   3.14159265358979323846
#endif

#ifdef __cplusplus
   }
#endif

#endif
