/*
   $RCSfile: utmemryu.h,v $       $Revision: 1.2 $
   $State: V6_2 $                  $Date: 2000/07/27 16:31:54 $
*/
#ifndef _UTMEMRYU_H
#define _UTMEMRYU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdlib.h>
#include <assert.h>

#include "uttypesu.h"

typedef struct {
   int StructType;
} GenericStruct, *pGenericStruct; 

#ifdef __STDC__
   extern pVoid utGetBytes(size_t nSize);
   extern void utFreeBytes(pVoid memoryBlock);
   extern void utSetMemoryTrackingOn();
   extern void utSetMemoryTrackingOff();
   extern void utReportAllocatedBlocks(char *label);
   extern void utReportAllocatedBlockPointers(char *label);
#ifdef BPTVMS
   extern void utCommandLineMemoryArguments(int *argc,
                                            char **argv);
#else
   extern void utCommandLineMemoryArguments(unsigned int *argc,
                                            char **argv);
#endif
#else
   extern pVoid utGetBytes();
   extern void utFreeBytes();
   extern void utSetMemoryTrackingOn();
   extern void utSetMemoryTrackingOff();
   extern void utReportAllocatedBlocks();
   extern void utReportAllocatedBlockPointers();
   extern void utCommandLineMemoryArguments();
#endif

#ifdef __cplusplus
   }
#endif

#endif
