/*
   $RCSfile: utstrcvu.h,v $       $Revision: 1.9 $
   $State: Exp $                  $Date: 2003/05/08 16:57:42 $
*/
#ifndef _UTSTRCVU_H
#define _UTSTRCVU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdio.h>
#include <string.h>

#include "uttypesu.h"

#ifdef __STDC__
   extern double utMachinePrecision();
   extern double utMachineTolerance();
   extern char *utIntToString(int integer);
   extern int utStringToInt(char *sInt);
   extern char *utLongToString(long integer);
   extern long utStringToLong(char *sLong);
   extern char *utDoubleToString(double value);
   extern double utStringToDouble(char *sDbl);
   extern void utDblStrToLimitedDblStr(char *s1,
                                       char *s2);
   extern char *utDoubleToFormattedString(double value,
                                          int width,
                                          int fPrecision,
                                          int gPrecision);
   extern char *utFormatDoubleToString(double value,
                                       char *format);
   extern char *utIntToFormattedString(int integer,
                                       int width);
   extern char *utFormatIntToString(int value,
                                    char *format);
   extern char *utLongToFormattedString(long value,
                                        int width);
   extern void utWriteFormattedDoubleToFile(FILE *fp,
                                            char *prefix,
                                            double value,
                                            int width,
                                            int fPrecision,
                                            int gPrecision,
                                            char *delimeter,
                                            char *suffix,
                                            utLogical newLine);
#else
   extern double utMachinePrecision();
   extern double utMachineTolerance();
   extern char *utIntToString();
   extern int utStringToInt();
   extern char *utLongToString();
   extern long utStringToLong();
   extern char *utDoubleToString();
   extern double utStringToDouble();
   extern void utDblStrToLimitedDblStr();
   extern char *utDoubleToFormattedString();
   extern char *utFormatDoubleToString();
   extern char *utIntToFormattedString();
   extern char *utFormatIntToString();
   extern char *utLongToFormattedString();
   extern void utWriteFormattedDoubleToFile();
#endif

#ifdef __cplusplus
   }
#endif

#endif
